SystemOrganization addCategory: #GuerrerosConTraits!

Trait named: #Atacante
	uses: {}
	category: 'GuerrerosConTraits'!

!Atacante methodsFor: 'as yet unclassified' stamp: 'Anonymous 3/28/2013 12:50'!
atacarA: otroGuerrero
	(self puedeAtacar: otroGuerrero)
	ifTrue: [otroGuerrero recibirDanio: (self potencialOfensivo - otroGuerrero potencialDefensivo)].! !

!Atacante methodsFor: 'as yet unclassified' stamp: 'Anonymous 3/28/2013 12:51'!
potencialOfensivo
 self requirement.! !

!Atacante methodsFor: 'as yet unclassified' stamp: 'Anonymous 3/28/2013 12:49'!
puedeAtacar: otroGuerrero
 ^(self potencialOfensivo > otroGuerrero potencialDefensivo)! !

Trait named: #Defensor
	uses: {}
	category: 'GuerrerosConTraits'!

!Defensor methodsFor: 'as yet unclassified' stamp: 'Anonymous 3/28/2013 13:00'!
energia
 self requirement.! !

!Defensor methodsFor: 'as yet unclassified' stamp: 'Anonymous 3/28/2013 12:59'!
energia: valor
 self requirement.! !

!Defensor methodsFor: 'as yet unclassified' stamp: 'Anonymous 3/28/2013 13:02'!
potencialDefensivo
 ^self requirement.! !

!Defensor methodsFor: 'as yet unclassified' stamp: 'Anonymous 3/28/2013 13:03'!
recibirDanio: valor
 self energia: (self energia - valor).! !

Object subclass: #Espada
	instanceVariableNames: 'potencia'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GuerrerosConTraits'!

!Espada methodsFor: 'as yet unclassified' stamp: 'Anonymous 3/28/2013 12:43'!
potencia
 ^potencia .! !

!Espada methodsFor: 'as yet unclassified' stamp: 'Anonymous 3/28/2013 12:43'!
potencia: valor
 potencia:=valor.! !

Object subclass: #Guerrero
	uses: Atacante + Defensor
	instanceVariableNames: 'energia potencialOfensivo potencialDefensivo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GuerrerosConTraits'!

Guerrero class
	uses: Atacante classTrait + Defensor classTrait
	instanceVariableNames: ''!

Guerrero subclass: #Espadachin
	instanceVariableNames: 'habilidad espada'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GuerrerosConTraits'!

!Espadachin methodsFor: 'as yet unclassified' stamp: 'Anonymous 3/28/2013 12:41'!
espada
 ^espada.! !

!Espadachin methodsFor: 'as yet unclassified' stamp: 'Anonymous 3/28/2013 12:41'!
espada: unaEspada
 espada := unaEspada.! !

!Espadachin methodsFor: 'as yet unclassified' stamp: 'Anonymous 3/28/2013 12:41'!
habilidad
 ^habilidad .! !

!Espadachin methodsFor: 'as yet unclassified' stamp: 'Anonymous 3/28/2013 12:41'!
habilidad: valor
 habilidad :=valor.! !

!Espadachin methodsFor: 'as yet unclassified' stamp: 'Anonymous 3/28/2013 12:42'!
potencialOfensivo 
 ^super potencialOfensivo + (self espada potencia * self habilidad)! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'Anonymous 3/28/2013 13:01'!
energia
 ^energia.! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'Anonymous 3/28/2013 13:02'!
energia: valor
 energia:=valor.! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'Anonymous 3/28/2013 12:55'!
potencialDefensivo
 ^potencialDefensivo.! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'Anonymous 3/28/2013 12:55'!
potencialDefensivo: valor
 potencialDefensivo := valor.! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'Anonymous 3/28/2013 12:56'!
potencialOfensivo
  ^potencialOfensivo.! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'Anonymous 3/28/2013 12:52'!
potencialOfensivo:valor
 potencialOfensivo := valor.! !

Object subclass: #Misil
	uses: Atacante
	instanceVariableNames: 'lalala'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GuerrerosConTraits'!

Misil class
	uses: Atacante classTrait
	instanceVariableNames: ''!

!Misil methodsFor: 'as yet unclassified' stamp: 'Anonymous 3/28/2013 12:44'!
potencialOfensivo 
	^1000.! !

Object subclass: #Muralla
	uses: Defensor
	instanceVariableNames: 'energia'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GuerrerosConTraits'!

Muralla class
	uses: Defensor classTrait
	instanceVariableNames: ''!

!Muralla methodsFor: 'as yet unclassified' stamp: 'Anonymous 3/28/2013 13:01'!
energia
 ^energia.! !

!Muralla methodsFor: 'as yet unclassified' stamp: 'Anonymous 3/28/2013 13:01'!
energia: valor
 energia:= valor.! !

!Muralla methodsFor: 'as yet unclassified' stamp: 'sebi 3/28/2013 13:27'!
potencialDefensivo
 ^100.! !

TestCase subclass: #GuerrerosTest
	instanceVariableNames: 'marco julio carlos espadita misil muralla'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GuerrerosConTraits'!

!GuerrerosTest methodsFor: 'as yet unclassified' stamp: 'sebi 3/28/2013 13:36'!
setUp
marco := Guerrero new.
marco energia: 1000.
marco potencialOfensivo: 100.
marco potencialDefensivo: 50.
julio := Guerrero new.
julio energia: 1000.
julio potencialOfensivo: 80.
julio potencialDefensivo: 110.
carlos := Espadachin new.
carlos energia: 1000.
carlos potencialOfensivo: 100.
carlos potencialDefensivo: 100.
carlos habilidad: 50.
espadita := Espada new.
espadita potencia: 2.
carlos espada: espadita.
misil := Misil new.
muralla:=Muralla new.
muralla energia: 1000.! !

!GuerrerosTest methodsFor: 'as yet unclassified' stamp: 'sebi 3/28/2013 13:43'!
testCarlosAtacaMuralla
 carlos atacarA: muralla.
 self assert: muralla energia equals: 900! !

!GuerrerosTest methodsFor: 'as yet unclassified' stamp: 'sebi 3/28/2013 13:40'!
testJulioAtacaMarco
 julio atacarA: marco.
 self assert: marco energia equals:970.! !

!GuerrerosTest methodsFor: 'as yet unclassified' stamp: 'sebi 3/28/2013 13:39'!
testMarcoAtacaJulio
 marco atacarA: julio. 
 self assert: (julio energia) equals: 1000.! !

!GuerrerosTest methodsFor: 'as yet unclassified' stamp: 'sebi 3/28/2013 13:42'!
testMisilAtacaCarlos
 misil atacarA: carlos.
 self assert: carlos energia equals: 100! !

!GuerrerosTest methodsFor: 'as yet unclassified' stamp: 'sebi 3/28/2013 13:41'!
testMisilAtacaJulio
 misil atacarA: julio.
 self assert: julio energia equals:110! !

!GuerrerosTest methodsFor: 'as yet unclassified' stamp: 'sebi 3/28/2013 13:41'!
testMisilCarlosAtacaJulio
 misil atacarA: julio.
 self assert: julio energia equals:110.
 carlos atacarA: julio.
 self assert: julio energia equals:20! !
